<?php

namespace Teknisa\SM\Controller;

use Teknisa\SM\Controller\SMCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;

class FctMedvarelementoscompController extends SMCrud {
    
    protected $dataSourceName = "medidas_variaveis_elementos_composicao";
    protected $dataSourceNameToSave = "fct_medvargeracaoprop";
    
    public function __construct($crudService, $environment) {
        parent::__construct($crudService, $environment);
    }

    public function find(Request\Filter $request, Response $response) {
        try {
            parent::find($request, $response);
            $erro = $response->getError();
            if ($erro) {
                throw new \Exception($erro->getMessage(), $erro->getErrorCode());
            }
                
            $rows = $response->getDataSets()[0]->getRows();
            foreach ($rows as &$row) {
                $row["__is_new"] = $row["EXISTE"] !== "S";
            }
            unset($row);
            $response->setDataSets(array(new DataSet($this->dataSourceName, $rows)));
        }
        catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
}

?>