/******************************************************************************/
/*                                                                            */
/* Nome: CARREGA_PERIFILI                                                     */
/*                                                                            */
/* Criao:                                                                   */
/*    26/10/2012 - Petterson Galdino                                          */
/*                                                                            */
/******************************************************************************/
CREATE OR REPLACE PROCEDURE CARREGA_PERIFILI
(
   P_CDFILIAL        IN FILIAL.CDFILIAL%TYPE,
   P_CDPRODUTO       IN PRODUTO.CDPRODUTO%TYPE,
   P_DTPROGENTAF     IN DATE,
   P_ERRO            OUT VARCHAR2
)
IS
   V_CDPERIENTR      VARCHAR2(2);
   V_IDTIPODIA       VARCHAR2(1);
   V_IDDIANUTIL      VARCHAR2(1);
   V_DIENTREGA       VARCHAR2(3);
   V_DTDIAENTR       VARCHAR2(3);
   V_COUNT           NUMBER;
   V_EXISTE          CHAR(1);
   V_DATA            DATE;
   V_NEW_DTPROGENTAF DATE;
BEGIN
   P_ERRO := 'N';
SELECT
      MAX(PERFILPROD.CDPERIENTR),
      MAX(PERIENTR.IDTIPODIA),
      MAX(PERIENTR.IDDIANUTIL) INTO V_CDPERIENTR, V_IDTIPODIA, V_IDDIANUTIL
  FROM PERFILPROD, PERIENTR
 WHERE PERFILPROD.CDFILIAL = P_CDFILIAL
   AND PERFILPROD.CDPERIENTR = PERIENTR.CDPERIENTR
   AND PERFILPROD.CDPRODUTO = (SELECT MAX(B.CDARVPROD)
                                 FROM PERFILPROD A, PRODUTO B
                                WHERE A.CDPRODUTO = B.CDPRODUTO
                                  AND A.CDFILIAL  = P_CDFILIAL
                                  AND INSTR(P_CDPRODUTO, B.CDARVPROD) = 1);
   V_NEW_DTPROGENTAF := P_DTPROGENTAF;
   V_EXISTE := NULL;
   IF V_IDTIPODIA = 'S' THEN
      V_DATA := TRUNC(P_DTPROGENTAF);
      BEGIN
         IF V_IDDIANUTIL = 'S' THEN
            SELECT '1' INTO V_EXISTE
            FROM DIASENTR
            WHERE
               TO_NUMBER(TO_CHAR(V_DATA, 'D')) = TO_NUMBER(DIASENTR.DIENTREGA)   AND
               DIASENTR.CDPERIENTR = V_CDPERIENTR AND
               (TRUNC((TO_NUMBER(TO_CHAR(V_DATA, 'DD')) + 6) / 7) + IDOCOR01 = 2 OR
                TRUNC((TO_NUMBER(TO_CHAR(V_DATA, 'DD')) + 6) / 7) + IDOCOR02 = 3 OR
                TRUNC((TO_NUMBER(TO_CHAR(V_DATA, 'DD')) + 6) / 7) + IDOCOR03 = 4 OR
                TRUNC((TO_NUMBER(TO_CHAR(V_DATA, 'DD')) + 6) / 7) + IDOCOR04 = 5 OR
                TRUNC((TO_NUMBER(TO_CHAR(V_DATA, 'DD')) + 6) / 7) + IDOCOR05 = 6) AND
                NOT EXISTS (SELECT 1
                              FROM FERICOMP
                             WHERE CDFILIAL = P_CDFILIAL
                               AND DTFERICOMP = P_DTPROGENTAF);
          ELSE
             SELECT '1' INTO V_EXISTE
               FROM DIASENTR
               WHERE
                  TO_NUMBER(TO_CHAR(V_DATA, 'D')) = TO_NUMBER(DIASENTR.DIENTREGA)   AND
                  DIASENTR.CDPERIENTR = V_CDPERIENTR AND
                  (TRUNC((TO_NUMBER(TO_CHAR(V_DATA, 'DD')) + 6) / 7) + IDOCOR01 = 2 OR
                   TRUNC((TO_NUMBER(TO_CHAR(V_DATA, 'DD')) + 6) / 7) + IDOCOR02 = 3 OR
                   TRUNC((TO_NUMBER(TO_CHAR(V_DATA, 'DD')) + 6) / 7) + IDOCOR03 = 4 OR
                   TRUNC((TO_NUMBER(TO_CHAR(V_DATA, 'DD')) + 6) / 7) + IDOCOR04 = 5 OR
                   TRUNC((TO_NUMBER(TO_CHAR(V_DATA, 'DD')) + 6) / 7) + IDOCOR05 = 6);
         END IF;
       EXCEPTION
         WHEN NO_DATA_FOUND THEN BEGIN
            V_EXISTE := NULL;
         END;
       END;
       IF (P_DTPROGENTAF - V_DATA) > 31 THEN
         V_EXISTE := '1';
       END IF;
   END IF;
   IF V_IDTIPODIA = 'R' THEN
      IF V_IDDIANUTIL = 'S' THEN
         BEGIN
            SELECT
               MAX(C.DTENTREGA) INTO V_NEW_DTPROGENTAF
            FROM
               CALECOMP C
            WHERE C.CDFILIAL    = P_CDFILIAL
              AND C.CDPERIENTR  = V_CDPERIENTR
              AND C.DTENTREGA   = P_DTPROGENTAF  AND
               NOT EXISTS (SELECT 1
                             FROM FERICOMP
                            WHERE CDFILIAL = P_CDFILIAL
                              AND DTFERICOMP = P_DTPROGENTAF);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN BEGIN
               V_NEW_DTPROGENTAF := NULL;
            END;
         END;
         IF V_NEW_DTPROGENTAF IS NOT NULL THEN
            V_EXISTE := '1';
         END IF;
      ELSE
         BEGIN
            SELECT
               MAX(C.DTENTREGA) INTO V_NEW_DTPROGENTAF
            FROM
               CALECOMP C
            WHERE C.CDFILIAL    = P_CDFILIAL
              AND C.CDPERIENTR  = V_CDPERIENTR
              AND C.DTENTREGA   = P_DTPROGENTAF;
         EXCEPTION
               WHEN NO_DATA_FOUND THEN BEGIN
                  V_NEW_DTPROGENTAF := NULL;
               END;
         END;
            IF V_NEW_DTPROGENTAF IS NOT NULL THEN
               V_EXISTE := '1';
            END IF;
      END IF;
   END IF;
   IF V_IDTIPODIA = 'M' THEN
      V_DIENTREGA := NULL;
      IF V_IDDIANUTIL = 'S' THEN
         BEGIN
            SELECT MAX(DIENTREGA) INTO V_DIENTREGA
            FROM
              (SELECT '-'||DIENTREGA DIENTREGA
               FROM DIASENTR
               WHERE CDPERIENTR = V_CDPERIENTR
               UNION ALL
               SELECT DIENTREGA
               FROM DIASENTR
               WHERE CDPERIENTR = V_CDPERIENTR)
            WHERE
               DIENTREGA <= TO_CHAR(P_DTPROGENTAF, 'DD') AND
            NOT EXISTS (SELECT 1
                                 FROM FERICOMP
                                WHERE CDFILIAL = P_CDFILIAL
                                  AND DTFERICOMP = P_DTPROGENTAF);
         EXCEPTION
             WHEN NO_DATA_FOUND THEN BEGIN
                V_DIENTREGA := NULL;
             END;
        END;
         IF V_DIENTREGA IS NULL THEN
            V_EXISTE := NULL;
         ELSE
            V_EXISTE := '1';
         END IF;
      ELSE
         BEGIN
            SELECT MAX(DIENTREGA) INTO V_DIENTREGA
            FROM
              (SELECT '-'||DIENTREGA DIENTREGA
               FROM DIASENTR
               WHERE CDPERIENTR = V_CDPERIENTR
               UNION ALL
               SELECT DIENTREGA
               FROM DIASENTR
               WHERE CDPERIENTR = V_CDPERIENTR)
            WHERE
               DIENTREGA <= TO_CHAR(P_DTPROGENTAF, 'DD');
         EXCEPTION
             WHEN NO_DATA_FOUND THEN BEGIN
                V_DIENTREGA := NULL;
             END;
         END;
         IF V_DIENTREGA IS NULL THEN
            V_EXISTE := NULL;
         ELSE
            V_EXISTE := '1';
         END IF;
      END IF;
   END IF;
   IF V_EXISTE IS NULL THEN
      P_ERRO := 'S';
   END IF;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('CARREGA_PERIFILI','5.33.xxx'); END;
/
